import type { QueueConsumerDependencies, QueueDependencies, QueueOptions } from '@message-queue-toolkit/core';
import { AbstractQueueService } from '@message-queue-toolkit/core';
import type { Channel, Connection } from 'amqplib';
import type { Options } from 'amqplib/properties';
import type { AMQPLocatorType } from './AbstractAmqpConsumer';
export type AMQPDependencies = QueueDependencies & {
    amqpConnection: Connection;
};
export type AMQPConsumerDependencies = AMQPDependencies & QueueConsumerDependencies;
export type AMQPQueueConfig = Options.AssertQueue;
export declare class AbstractAmqpService<MessagePayloadType extends object, DependenciesType extends AMQPDependencies = AMQPDependencies> extends AbstractQueueService<MessagePayloadType, DependenciesType, AMQPQueueConfig> {
    protected readonly connection: Connection;
    protected channel: Channel;
    private isShuttingDown;
    constructor(dependencies: DependenciesType, options: QueueOptions<MessagePayloadType, AMQPQueueConfig, AMQPLocatorType>);
    private destroyConnection;
    init(): Promise<void>;
    close(): Promise<void>;
}
